/* 

        
    ,-"```"-,              |       ,-"-,   
    |       |              |       |   "
    |       )   ,-"``"-,   |       |     
    |:-----:           |   |      -+--,          
    |       )   ,-""""-|   |       |         
    |       |   |      |   |  ,    |           
    `"-,,,-"`   `-,,,-'|   ',-'    |               

    BALF v 0.2 Beta

Made by Johan Talboom (johantalboom@yahoo.com)


                TODO:
  - Add some levels
  - (New) background in game
  - movesconunter
  - start bug
  - restart key
  - ????????????????????????

*/






#include <ti.h>
#include <sprite.c>
#include <itoa.c>
#include <fastcopy.h>
#include <line.c>
#include <box.c>


#define setboard(x,y,v) board[(y*7)+x] = v
#define getboard(x,y)   board[(y*7)+x]

#name "Balf 0.2 beta"

char board[49];
char xpos,ypos;
char xmov, ymov;
char level;
char temp;
char inloop;
char key;
char a,b,c,d,e,f,g,h;


extern char _full[8];
extern char _block[8];
extern char _empty[8];
extern char _balfU[8];
extern char _balfD[8];
extern char _balfL[8];
extern char _balfR[8];

extern char levels[];

main() {

 indicatoroff;
 clrlcd;
 clrscrn;
 level = 1;
 inloop = 0;

 for(temp = 0; temp < 49; temp++)
  board[temp] = 0;

 clearbuffer;
 clrlcd;
 clrscrn;

#asm
 ld hl,intro
 ld de,PLOTSSCREEN 
 ld bc,768 
 ldir
#endasm

 FastCopy();
 while(getkey() == 0);

 clearbuffer;
 clrlcd;
 clrscrn;

 while (inloop == 0)
 {
  GetBoard();
  DrawBoard();
 
  sprite(_full, 75, 27,8,8);
  xpos = -1;
  ypos = 3;
  sprite(_balfU, 8*xpos+19, 8*ypos + 3,8,8);
  FastCopy();
  sprite(_empty, 8*xpos+19, 8*ypos + 3,8,8);
  
  while (inloop ==  0) {
   key = getkey(); 

   xmov = 0;
   ymov = 0;
 
   if(key == kExit || key == kQuit || key == kDEL)
    inloop = 1;
   if(key == kUp && ypos > 0)
   {
    ymov = -1;
    xmov = 0;
   }
   if(key == kDown && ypos < 6)
   {
    ymov = 1;
    xmov = 0;
   }
   if(key == kRight && xpos < 6)
   {
    ymov = 0;
    xmov = 1;
   }
   if(key == kRight && xpos == 6 && ypos == 3) inloop = 1;
   if(key == kLeft && xpos > 0)
   {
    ymov = 0;
    xmov = -1;
   }
   if(xmov != 0 || ymov != 0)
   {
    xpos+=xmov;
    ypos+=ymov;
    if (getboard(xpos,ypos) == 1)
    {
     e = xpos;
     f = xpos; 
     g = ypos;
     h = ypos;
 
     if (xpos != 0) e = xpos - 1;
     if (xpos != 6) f = xpos + 1;
     if (ypos != 0) g = ypos - 1;
     if (ypos != 6) h = ypos + 1;

     for(a = e; a < f+1; a++)
     {
      for(b = g; b < h+1; b++)
      {
       if (getboard(a,b)==1)
       {
        setboard(a,b,0);
        sprite(_empty, 8*a+19, 8*b + 3,8,8);
       }
       else if (getboard(a,b)==0)
       {
        setboard(a,b,1);
        sprite(_full, 8*a+19, 8*b + 3,8,8);
       }
      }
     }
 
    }
    else
    {
     xpos-=xmov;
     ypos-=ymov;
    }    

    if (xmov == 0 && ymov == -1) sprite(_balfU, 8*xpos+19, 8*ypos + 3,8,8);
    if (xmov == 0 && ymov == 1)  sprite(_balfD, 8*xpos+19, 8*ypos + 3,8,8);
    if (xmov == -1 && ymov == 0) sprite(_balfL, 8*xpos+19, 8*ypos + 3,8,8); 
    if (xmov == 1 && ymov == 0)  sprite(_balfR, 8*xpos+19, 8*ypos + 3,8,8); 

   }
   FastCopy();
  }

  if(key == kRight && xpos == 6 && ypos == 3)
  {
   if (level < 2) level++;
   inloop = 0;
  }

 }
}



GetBoard() {
 char x;
 char y;
 int position;
 char p;

 position = 16 * (level-1);
 p = 0;
 while(p < 49)
 {
  board[p]   = (levels[position] >> 6) & 1;
  board[p+1] = (levels[position] >> 5) & 1;
  board[p+2] = (levels[position] >> 4) & 1;
  board[p+3] = (levels[position] >> 3) & 1;
  board[p+4] = (levels[position] >> 2) & 1;
  board[p+5] = (levels[position] >> 1) & 1;
  board[p+6] = (levels[position]) & 1;
 
  position++;
  p+=7;
 }
 position++;
 p = 0;
 while(p < 49)
 {
  if  (((levels[position] >> 6) & 1) == 1) board[p]   = 2;
  if  (((levels[position] >> 5) & 1) == 1) board[p+1] = 2;
  if  (((levels[position] >> 4) & 1) == 1) board[p+2] = 2;
  if  (((levels[position] >> 3) & 1) == 1) board[p+3] = 2;
  if  (((levels[position] >> 2) & 1) == 1) board[p+4] = 2;
  if  (((levels[position] >> 1) & 1) == 1) board[p+5] = 2;
  if  (((levels[position]) & 1)      == 1) board[p+6] = 2;

  position++;
  p+=7;
 }
}


DrawBoard() {

 char x;
 char y;
 char templ[25];
 int templev;

/* Show which level you are in */
 clrlcd;
 clrscrn;
 clearbuffer;

 templev = level;
 itoa(templ, templev);

 box(20,28,74,42,PT_ON);
 FastCopy();
 setxy(4,4);
 puts("Level ");
 puts(templ);

 while(getkey() == 0);

 clearbuffer;
 clrlcd;
 clrscrn;

 line(17,1,76,1,PT_ON);
 line(17,60,76,60,PT_ON);
 line(17,1,17,60,PT_ON);
 line(76,1,76,60,PT_ON);
 box(9,25,17,36,PT_CHG);
 box(76,25,84,36,PT_CHG);

 for(x=0; x<7; x++) {
  for(y=0; y<7; y++) {
   if (getboard(x,y) == 2) sprite(_block, (x*8)+19, (y*8)+3,8,8);
   if (getboard(x,y) == 1) sprite(_full, (x*8)+19, (y*8)+3,8,8);
  }
 }

 FastCopy();

}


#asm

_block:
  .db   11111111b
  .db   10011001b
  .db   10011001b
  .db   11111111b
  .db   11111111b
  .db   10011001b
  .db   10011001b
  .db   11111111b
_empty:
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
_full:
  .db   00111100b
  .db   01111110b
  .db   11111111b
  .db   11111111b
  .db   11111111b
  .db   11111111b
  .db   01111110b
  .db   00111100b
_balfU:
  .db   00111100b
  .db   01111110b
  .db   11000011b
  .db   10100101b
  .db   10000001b
  .db   10000001b
  .db   01111110b
  .db   00111100b
_balfD:
  .db   00111100b
  .db   01111110b
  .db   10000001b
  .db   10000001b
  .db   10100101b
  .db   11000011b
  .db   01111110b
  .db   00111100b
_balfL:
  .db   00111100b
  .db   01100010b
  .db   11010011b
  .db   11000011b
  .db   11000011b
  .db   11010011b
  .db   01100010b
  .db   00111100b
_balfR:
  .db   00111100b
  .db   01000110b
  .db   11001011b
  .db   11000011b
  .db   11000011b
  .db   11001011b
  .db   01000110b
  .db   00111100b


levels:
; level 1
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   01000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b

  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b

; level 2
  .db   00000000b
  .db   00000000b
  .db   00100100b
  .db   01011011b
  .db   00100100b
  .db   00000000b
  .db   00000000b
  .db   00000000b

  .db   00000000b
  .db   00000000b
  .db   00000001b
  .db   00100100b
  .db   00000001b
  .db   00000000b
  .db   00000000b
  .db   00000000b


intro:
	.db %00000000,%10000000,%00100000,%00000010,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%10000001,%00000000
	.db %00100000,%00100001,%00000111,%11110000,%10001001,%00100100,%00000001,%11000010,%00001111,%11000100,%00100000,%01000000
	.db %00000100,%00000000,%00000111,%11111000,%00000000,%00000001,%00000111,%11100000,%00111111,%11110000,%00000000,%00010000
	.db %00000000,%00001000,%00011111,%00001100,%00000000,%00000000,%00100111,%11100000,%01100011,%11110000,%10000100,%00000000
	.db %00010001,%00000000,%10011111,%00100110,%00100001,%00100000,%00000111,%11100000,%11001000,%11111000,%00000001,%00000000
	.db %00000000,%01000000,%00011111,%00000110,%00001000,%00000100,%00000111,%11100010,%11000001,%11111000,%00010000,%00100000
	.db %00000000,%00000010,%00111110,%00001110,%00000000,%00000001,%00000111,%11100000,%11000001,%11111000,%10000000,%00000100
	.db %00100100,%00010000,%00011111,%00000110,%01000000,%00000000,%01000111,%11100000,%11000000,%01101000,%00000010,%00000000
	.db %00000001,%00000000,%00011111,%00100110,%00000001,%01110000,%00000111,%11100000,%11101101,%00000000,%00010000,%01000000
	.db %00000000,%00000010,%01011110,%00000110,%00000111,%11111110,%00010011,%11100010,%11111111,%10000001,%00000000,%00001000
	.db %00010000,%01000000,%00011111,%00000110,%00101111,%11001110,%00000111,%11100000,%11111101,%00100000,%00000010,%00000000
	.db %00000100,%00010000,%00011111,%00001100,%00001111,%11000011,%00000111,%11100000,%11111000,%00001000,%01000000,%01000000
	.db %00000000,%00000000,%10011111,%11111100,%10001111,%10010011,%01000111,%11100000,%11111100,%00000000,%00010000,%00000000
	.db %00100000,%10000100,%00011111,%11111100,%00000111,%00000011,%00000111,%11100010,%11111100,%10000001,%00000001,%00010000
	.db %00000000,%00000000,%00111110,%00001110,%00000000,%00000111,%00000111,%11100000,%11111100,%00010000,%00000000,%00000100
	.db %00001000,%00100001,%00011111,%00000110,%00100011,%11111111,%00010011,%11100000,%11111100,%00000000,%01000100,%00000000
	.db %00000010,%00000000,%00011111,%00100110,%00001111,%11111111,%00000111,%11100000,%11111000,%01000100,%00000000,%01000000
	.db %00100000,%00001000,%00011110,%00000110,%00001110,%00111111,%00000111,%11100100,%11111100,%00000000,%00010000,%00010000
	.db %00000000,%10000000,%01011111,%00000110,%00001100,%00011111,%01000111,%11100000,%11111100,%00000001,%00000001,%00000000
	.db %00000100,%00000010,%00011110,%00000110,%01001100,%00111111,%00000111,%11100000,%11111100,%00100000,%00000000,%00000000
	.db %00100000,%00100000,%00011111,%00001110,%00001110,%00111111,%00000111,%11100000,%11111100,%00001000,%00100000,%00100100
	.db %00000000,%00000000,%00011111,%11111100,%00010111,%11111110,%00010011,%11100100,%11111100,%00000000,%00001001,%00000000
	.db %00000010,%00001000,%10001111,%11111001,%00000011,%11111110,%00000111,%11100000,%11111100,%10000010,%00000000,%00000000
	.db %00010000,%10000000,%00000111,%11111000,%00000011,%11111100,%10000111,%11000001,%01111000,%00100000,%10000000,%00001000
	.db %00000111,%10000010,%00100010,%00000001,%00100000,%00000000,%00001111,%10100000,%01101000,%00000000,%00010010,%01000000
	.db %00000100,%01100000,%00001010,%10000001,%00001000,%10000000,%00100010,%00001000,%01001010,%00001000,%00000000,%00000000
	.db %00100100,%01010001,%00000010,%00110011,%11000011,%10111110,%00000010,%00001110,%01001110,%10011010,%01100011,%11110000
	.db %00000111,%11001110,%01000010,%01101001,%00100000,%10010010,%00000110,%01000010,%11001001,%00100100,%11010010,%01101000
	.db %00001100,%01001010,%00000110,%01001001,%01100011,%10010010,%10000010,%00001110,%01001001,%00100100,%10010110,%01001100
	.db %00000110,%01001010,%00010010,%01001001,%00101100,%10010010,%00100010,%00010010,%01011001,%00100100,%10010010,%01001000
	.db %00100111,%10100101,%00111101,%00111001,%00100111,%11010010,%00000011,%00111110,%01001111,%00111010,%01110010,%01001000
	.db %00000000,%00000100,%00000000,%00000010,%00000000,%00010000,%00000000,%00000100,%00000000,%00000000,%00000000,%10000000
	.db %00000000,%00001000,%00000000,%00000000,%00100100,%00001111,%11111110,%00000000,%10000000,%00000000,%00000000,%00100000
	.db %00010010,%01001001,%00010010,%01001000,%00000000,%11110010,%10101001,%11100000,%00010010,%01001001,%00100010,%00001000
	.db %00000000,%00000000,%00000000,%00000000,%10000011,%10010101,%00010101,%00111000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%00001100,%10101010,%10100010,%01010110,%00000000,%00000000,%00000000,%00000000
	.db %10100101,%00101001,%01010010,%01001010,%00110101,%00101001,%01010100,%10001011,%01001001,%01001010,%01001010,%10100100
	.db %00101001,%01001010,%10010101,%01010010,%11101010,%10100010,%00100101,%01010001,%11101010,%01010010,%10101001,%01010100
	.db %01001010,%10010010,%01010010,%10101010,%11010010,%01010101,%01001001,%00100101,%00110010,%10100101,%01010010,%01001010
	.db %10101001,%01010101,%01010100,%10010101,%01010101,%01001010,%01010100,%01001010,%01010100,%10010100,%10010101,%01010100
	.db %01010101,%00101010,%10010101,%00110011,%01010101,%01010010,%10001010,%10010000,%10011010,%10101010,%10101010,%10010010
	.db %01001010,%10100100,%10100101,%01000110,%10010111,%10101010,%01010001,%01010101,%00101101,%01010010,%10010010,%01010100
	.db %01010010,%10101010,%10010100,%10101101,%01010110,%11010100,%10100101,%01100100,%10010100,%10010100,%10101010,%10100100
	.db %10101010,%01010101,%01010101,%01011010,%01010111,%10101001,%01001010,%10111001,%00100111,%01010101,%01010101,%01010100
	.db %01001010,%10010100,%10101001,%01001101,%01010111,%11100101,%00010010,%11101010,%01001010,%10101001,%00100101,%00101010
	.db %01010100,%10100101,%01001010,%10011010,%10101011,%10101001,%01101011,%11110100,%10010011,%01001010,%10101001,%01010010
	.db %10101010,%10101010,%10101010,%10110101,%01010101,%01001010,%00001010,%11011001,%00100101,%01010101,%01010101,%01010100
	.db %01001010,%10010101,%01010100,%10111010,%10010101,%01010101,%01010001,%01100010,%01001001,%10101010,%10101010,%01001010
	.db %01010100,%10101001,%01010101,%01010100,%10101001,%01001000,%10100101,%01010100,%10010011,%01001001,%00100101,%01010100
	.db %10101010,%10101010,%01010010,%10011010,%10101010,%10010101,%00101010,%00101001,%00100101,%10101010,%10101010,%10101010
	.db %01010101,%01001010,%10010101,%01110101,%00100101,%00101001,%01001001,%01000010,%01001001,%01010101,%01010101,%01010010
	.db %01001010,%10101010,%10101010,%10011010,%10101001,%01010010,%10010010,%01010100,%10010011,%01010101,%01010101,%01010100
	.db %10101010,%10101010,%10101010,%10110101,%01010101,%00101010,%00100100,%10001001,%00100101,%10100101,%01010010,%10101010
	.db %01010010,%01010010,%01010010,%01010101,%01001010,%10100100,%10101001,%01010010,%01001011,%01010100,%10010100,%10010100
	.db %10101010,%10101010,%10101010,%10110101,%01010010,%01001001,%01001010,%00010100,%10010001,%10101010,%10101010,%10101010
	.db %01010101,%01010101,%01010101,%01010100,%10101010,%10101010,%10010010,%10100001,%00100101,%01010101,%01010101,%01010100
	.db %10101010,%10101010,%10101010,%10110101,%00101010,%10101001,%00100100,%01001010,%01010011,%01010101,%01010101,%01010100
	.db %01010101,%01010101,%01010101,%01011010,%10100100,%10010010,%10101010,%10100100,%10001011,%01010101,%01010101,%01010100
	.db %10101010,%10101010,%10101010,%10101111,%01010101,%00100101,%00100100,%10010010,%01011101,%01010101,%01010101,%01010100
	.db %01010101,%01010101,%01010101,%01010101,%11111110,%10101010,%01001001,%00101111,%11110101,%01010101,%01010101,%01010100
	.db %10101010,%10101010,%10101010,%10101010,%10101011,%11111111,%11111111,%11111010,%10101010,%10101010,%10101010,%10101010
	.db %01010101,%01010101,%01010101,%01010101,%01010101,%01010101,%01010101,%01010101,%01010101,%01010101,%01010101,%01010100
	.db %10101010,%10101010,%10101010,%10101010,%10101010,%10101010,%10101010,%10101010,%10101010,%10101010,%10101010,%10101010
#endasm